{$A+,B+,D-,E+,F-,G+,I-,L-,N-,O-,R-,S-,V-,X+}
unit dets3;
interface

 function s3detect : boolean;

implementation

function RegBit(PAddr : word;mask : byte): Boolean;
var old : byte;
begin
 RegBit := true;
 old := port[PAddr];                                {save register}
 port[PAddr] := old and not mask;                   {reset bits}
 if port[PAddr] and mask <> 0 then RegBit := false
 else begin
   port[PAddr] := old or mask;                      {set bits}
   if port[PAddr] and mask <> mask then RegBit := false;
 end;
 port[PAddr] := old;                                {restore register}
end;

function s3detect : boolean;
var tmp: byte;
begin
 s3detect := False;
 port[$3D4] := $38;   {Index Lock Register         }
 tmp := port[$3D5];   {save register               }
 port[$3D5] := $48;   {unlock extended S3-registers}
 port[$3D4] := $35;   {Index Bank Select Register  }
 if RegBit($3D5,$0F) then begin { Bit 0..3 useable }
   port[$3D4] := $38; {Index Lock Register         }
   port[$3D5] := 0;   {lock extended S3-registers  }
   port[$3D4] := $35; {Index Bank Select Register  }
   s3detect := not RegBit($3D5,$0F);
 end;                 {card is S3, if bits 0..3 are zero}
 port[$3D4] := $38;
 port[$3D5] := tmp;   {restore register            }
end;

end.
